Program Make_Quake_PAK;

{IF YOU WANT TO USE THIS SOURCECODE FOR YOUR OWN PROGRAM YOU
 HAVE TO READ THE README.TXT FIRST}

type
  dirblock               = record
                             filename    : array[1..56] of byte;
                             Offset, len : longint;
                           end;

var
 dirblocks               : array[1..480] of dirblock;
 file1, file2            : file;
 buffer                  : array[0..32767] of byte;
 infile, outfile,lstfile : string;
 i                       : integer;
 directory               : text;
 cnt, dirbegin, dirsize  : longint;
 result, direntry        : word;
 b                       : array[1..13] of byte;

begin
  if paramcount < 1 then
  begin
    writeLn('Usage:   MAKE_PAK  pakfile');
    halt;
  end;
  infile := paramstr(1);
  for i := 1 to length(infile) do
    infile[i] := upcase(infile[i]);
  if pos('.PAK', infile) = 0 then
  begin
    lstfile := infile + '.LST';
    infile := infile + '.PAK';
  end
  else
  begin
    lstfile := copy(infile, 1, length(infile) - 4) + '.LST';
  end;
  assign(file1, infile);
  rewrite(file1,1);
  b[1] := 80;
  b[2] := 65;
  b[3] := 67;
  b[4] := 75;
  blockwrite(file1,b,4,result);
  dirbegin := 0;
  blockwrite(file1,dirbegin,4,result);
  assign(directory,lstfile);
  reset(directory);
  dirsize := 0;
  while not eof(directory) do
  begin
    readln(directory,outfile);
    inc(dirsize);
  end;
  reset(directory);
  dirsize := dirsize * 64;
  blockwrite(file1,dirsize,4,result);
  cnt := 0;
  while not eof (directory) do
  begin
    readln(directory,outfile);
    assign(file2, outfile);
    for i := 1 to length(outfile) do
      if outfile[i] = '\' then outfile[i] := '/';
    writeln(outfile);
    reset(file2, 1);
    inc(direntry);
    dirblocks[direntry].Offset := filepos(file1);
    dirblocks[direntry].len := filesize(file2);
    for i := 1 to 56 do
      if i <= length(outfile) then
        dirblocks[direntry].filename[i] := ord(outfile[i])
      else
        dirblocks[direntry].filename[i] := 0;
    inc(cnt);
    while not eof(file2) do
    begin
      blockread(file2, buffer, 32768, result);
      blockwrite(file1, buffer, result, result);
    end;
    close(file2);
  end;
  dirbegin := filepos(file1);
  seek(file1,4);
  blockwrite(file1,dirbegin,4,result);
  seek(file1,dirbegin);
  for direntry := 1 to cnt do
    blockwrite(file1,dirblocks[direntry],64,result);
  close(file1);
  close(directory);
end.

